

var mozileScriptSource = "chrome://mozile/content/";

// Define the default XHTML namespace to use in XML documents
var XHTMLNS = "http://www.w3.org/1999/xhtml";


// Set initial preferences


netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
var mozilePrefs = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch(null);	


try {

	mozilePrefs.getBoolPref("mozile.caretAlwaysOn");

} catch(e) {

	mozilePrefs.setBoolPref("mozile.caretAlwaysOn",false);

}


try {

	mozilePrefs.getBoolPref("mozile.neverEnhance");

} catch(e) {

	mozilePrefs.setBoolPref("mozile.neverEnhance",false);

}


try {

	mozilePrefs.getCharPref("mozile.debugLevel");

} catch(e) {

	mozilePrefs.setCharPref("mozile.debugLevel","0");

}


try {

	mozilePrefs.getCharPref("mozile.enhancedModulesList");

} catch(e) {

	mozilePrefs.setCharPref("mozile.enhancedModulesList","CopyCutPaste;UndoRedo;LocalFile");

}

try {

	mozilePrefs.getCharPref("mozile.enhancedFunctionsList");

} catch(e) {

	mozilePrefs.setCharPref("mozile.enhancedFunctionsList","mozile.open;mozile.showCaret;mozile.hideCaret;mozile.doCopy;mozile.doCut;mozile.doPaste;mozile.saveToDialog;mozile.saveToFile");

}


try {

	mozilePrefs.getCharPref("mozile.enhancedAllowedList");

} catch(e) {

	mozilePrefs.setCharPref("mozile.enhancedAllowedList","");

}


try {

	mozilePrefs.getCharPref("mozile.enhancedForbiddenList");

} catch(e) {

	mozilePrefs.setCharPref("mozile.enhancedForbiddenList","");

}






function testAlert() {
	try{
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect UniversalBrowserWrite ");
		alert("Mozile Extension Privileged! Extension: "+ mozile.extension);
	}	catch(e){
		alert("Mozile Extension Unprivileged! "+e);
	}
}


function mozileOptions() {
	window.openDialog("chrome://mozile/content/extension/options.xul", "Mozile Options", "chrome");
}




// Listen for these events, and check to see if Mozile is loaded.

document.addEventListener("focus", mozileExtend, false);
document.addEventListener("click", mozileExtend, false);
document.addEventListener("keydown", mozileExtend, false);

function mozileExtend(event) {

	try {
		mozile.extension = true;
		var target = document.commandDispatcher.focusedWindow;
		if(!target.mozile) {
			mozile.hideCaret();
			return false;
		}
		if(target == window) return false;
		
		// Check to see if we should enhance this page
		if(!mozilePrefs.getBoolPref("mozile.neverEnhance") && !target.mozileDoNotEnhance && target.mozile && !target.mozile.extended) {
			var host;
			if(target.document.location.protocol == "file:") {
				host = "local files";
			} 
			else {
				host = target.document.location.host;
			}

			// Make sure the site is not on the black list. If it is, then return.
			var forbiddenArray = mozilePrefs.getCharPref("mozile.enhancedForbiddenList").split(";");
			for(i in forbiddenArray) {
				if(host == forbiddenArray[i]) {
					return false;
				}
			}
			
			// Check to see if the site is on the white list. If it is, then enhance.
			var allowedArray = mozilePrefs.getCharPref("mozile.enhancedAllowedList").split(";");
			for(i in allowedArray) {
				if(host == allowedArray[i]) {
					mozileOverride(target);
					return true;
				}
			}
			
			//alert(target +" "+ target.document.documentElement.nodeName);
			// Ask the user about enhancing the page.
			window.openDialog("chrome://mozile/content/extension/warning.xul", "Mozile Warning", "chrome", [host]);
		}
		else {
			//alert("No mozile instance.");
		}
	} catch(e) {
		//alert("Some sort of error! "+e);
	}
}



function mozileHandleWarning(code, host) {
	// I hope this is the right target
	var target = document.commandDispatcher.focusedWindow;

	var prefString, prefArray, host;
	switch(code) {
		case "thisPage":
			mozileOverride(target);
			break;

		case "alwaysThisSite":
			prefString = mozilePrefs.getCharPref("mozile.enhancedAllowedList");
			prefArray = prefString.split(";");
			prefArray.push(host);
			prefString = prefArray.join(";");
			mozilePrefs.setCharPref("mozile.enhancedAllowedList", prefString);
			mozileOverride(target);
			break;
			
		case "notThisPage":
			target.mozileDoNotEnhance = true;
			break;

		case "neverThisSite":
			target.mozileDoNotEnhance = true;
			prefString = mozilePrefs.getCharPref("mozile.enhancedForbiddenList");
			prefArray = prefString.split(";");
			prefArray.push(host);
			prefString = prefArray.join(";");
			mozilePrefs.setCharPref("mozile.enhancedForbiddenList", prefString);
			break;
			
		case "neverAtAll":
			mozilePrefs.setBoolPref("mozile.neverEnhance", true);
			break;
		
		default:
			// Do nothing
			break;
	}

	return true;
}



function mozileOverride(target) {

	// Try to get the pref string
	var prefString;
	try {
		prefString = mozilePrefs.getCharPref("mozile.enhancedFunctionsList");
	}
	catch(e) {
		alert("Failed to get mozile.enhancedFunctionsList preference: "+e);
	}
	
	var prefArray = prefString.split(";");
	
	// Override each function named in the prefArray. Make the 
	var setPref;
	for(p in prefArray) {
		var name = prefArray[p];
		// function/method/property names contain only alphanumeric characters, the underscore, and periods.
		var nonWS = /^[\w|\.]+$/;
		if(nonWS.test(name)) {
			setPref = "if(target."+ name +") target."+ name +" = "+ name;
			//alert(setPref);
			eval(setPref);
		}
	}

	target.mozile.extended = true;
	window.status = "Mozile Override Successful";
}









function mozileEditPage() {

	var target = document.commandDispatcher.focusedWindow;
	
	//alert(target +"\n"+ target.mozile);
	//alert(target +"\n"+ target.mozile);
	//alert(target +"\n"+ target.location +"\n"+ target.mozile +"\n"+ target.document +"\n"+ target.document.mozile);
	//return true;
	
	if(target.mozile) {
		mozileOverride(target);
		window.status = "Mozile Override Successful";
		return true;
	}
	

	
	var scriptTag ="";
	
	// Check to see if this is an X/HTML or an XUL document.
	var rootName = target.document.documentElement.tagName.toLowerCase();
	if(rootName=="html" || rootName=="xul") {
		// Build the required script tag in the default namespace
		scriptTag = target.document.createElement("script");
	}
	// If it's not X/HTML or XUL, assume it's generic XML
	else {
		// Build the required script tag in the XHTML namespace
		scriptTag = target.document.createElementNS(XHTMLNS,"script");
	}
	
	// Try to get the head tag for the document
	var head = target.document.getElementsByTagName("head")[0];
	
	// If no mozileScriptSource is given, try to get the src attribute of the script tag in the original document which points to this file.
	if(mozileScriptSource=="") {
		alert("Error! No mozileScriptSource!");
		return false;
	}
	
	// Finish building the script tag
	scriptTag.setAttribute("id","Mozile-Core-mozile.js");
	scriptTag.setAttribute("type","application/x-javascript");
	var src = mozileScriptSource +"extension/mozile.js";
	scriptTag.setAttribute("src",src);
		
	// If the head is defined, append the script tag to the head.
	if(head) {
		head.appendChild(scriptTag);
	}
	// If the head is not defined, insert the tag at the very top of the document.
	else {
		target.document.documentElement.insertBefore(scriptTag, target.document.documentElement.firstChild);
	}
	
	window.status = "Mozile Injection Successful";
	
	return true;

}


